/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

(function(window) {

function createCheckerOrt(x, y) {
    return function() {
        if (!this.pfeile.length)
            return 'Zeichne zuerst einen Pfeil ein, der auf den Bildpunkt zeigt…';
        const lastPfeil = this.pfeile[this.pfeile.length - 1];
console.log({ x: lastPfeil.x2, y: lastPfeil.y2 });
        return (lastPfeil.x2 == x && lastPfeil.y2 == y);
    }
}

const LEVELS = [
    {
        "task": "<p>Du siehst einen Ausschnitt eines Lichtbündels. Zeichne einen Pfeil, der auf den Punkt zeigt, von dem das Licht (scheinbar) kommt.</p><p>Du kannst beliebig viele Pfeile als Hilfslinien einzeichnen, nur der letzte Pfeil muss auf den gesuchten Punkt zeigen.</p>",
        "shadows": [
            { type: 'image', src: 'szenario1.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerOrt(80, 10)
    },
    {
        "task": "<p>Du siehst einen Ausschnitt eines Lichtbündels. Zeichne einen Pfeil, der auf den Punkt zeigt, von dem das Licht (scheinbar) kommt.</p><p>Du kannst beliebig viele Pfeile als Hilfslinien einzeichnen, nur der letzte Pfeil muss auf den gesuchten Punkt zeigen.</p>",
        "shadows": [
            { type: 'image', src: 'szenario2.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerOrt(55, 35)
    },
    {
        "task": "<p>Du siehst einen Ausschnitt eines Lichtbündels. Zeichne einen Pfeil, der auf den Punkt zeigt, von dem das Licht (scheinbar) kommt.</p><p>Du kannst beliebig viele Pfeile als Hilfslinien einzeichnen, nur der letzte Pfeil muss auf den gesuchten Punkt zeigen.</p>",
        "shadows": [
            { type: 'image', src: 'szenario3.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerOrt(25, 45)
    },
    {
        "task": "<p>Du siehst einen Ausschnitt eines Lichtbündels. Zeichne einen Pfeil, der auf den Punkt zeigt, von dem das Licht (scheinbar) kommt.</p><p>Du kannst beliebig viele Pfeile als Hilfslinien einzeichnen, nur der letzte Pfeil muss auf den gesuchten Punkt zeigen.</p>",
        "shadows": [
            { type: 'image', src: 'szenario4.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerOrt(30, 15)
    }
];

window.karokonstruktionTask = {
    levels: LEVELS
};
})(window);
